Unit Acs;
{$I Sys75.Inc}

Interface

Uses
  Spuds;

Function HasAcs (Str: AcsStr): BoOleAn;
Function UserHasAcs (Var U: tUserData; Str: AcsStr): BoOleAn;
Function SysopAcs: BoOleAn;
Function CoSysopAcs: BoOleAn;

const
  ibepimping: boolean = false;

Implementation

Uses
  TotStr, TotDate, TotMisc,
  Menus, Misc, Users, RemEmu, Emu, msgspon, filespon;

Function UserHasAcs (Var U: tUserData; Str: AcsStr): BoOleAn;
Var
  wow: ^tuserdata;
Begin
  getmem (wow, sizeof (tuserdata));
  wow^ := user;
  user := U;
  userhasacs := HasAcs (Str);
  user := wow^;
  freemem (wow, sizeof (tuserdata));
End;

Function HasAcs (Str: AcsStr): BoOleAn;
Var
  C: Char;
  L: LongInt;
  n: Datetimerec;
  Wo, S: String;
  Bool: BoOleAn;
  Snot: BoOleAn;
  Snort: BoOleAn;

  Procedure Bad;
  Begin
    ErrorLog ('|15Bad ACS String|08: |01' + Wo);
    ComWriteLn ('|15'^M^J'Fatal error|08: |09Bad ACS String |08(|01' + Wo + '|08).');
    Bool := False;
    Str := '';
  End;

  Function ReadNum: LongInt;
  Var
    B: Byte;
  Begin
    B := 1;
    While (B <= Length (Str)) And (Str [B] In ['0'..'9']) do
      If B < 9 Then
        Inc (B)
      Else Begin
        Bad;
        ReadNum := 0;
        Exit;
      End;
    Dec (B);
    ReadNum := StrToInt (Copy (Str, 1, B));
    Delete (Str, 1, B);
  End;

  Procedure Comp (B: BoOleAn);
  Begin
    If Snot Then Begin
      If Snort Then
        Bool := Bool Or Not B
      Else
        Bool := Bool And Not B;
      Snot := False;
    End Else
      If Snort Then
        Bool := Bool Or B
      Else
        Bool := Bool And B;
  End;

Begin
  Wo := Str;
  Bool := True;
  Snot := False;
  Snort := False;

  { ABCDEFGHIJKLMNOPqRSTUVWXYZ*~()|\=[;' }

  While Str <> '' do Begin
    C := uCase (Str [1]);
    Delete (Str, 1, 1);
    Case C of
      '~': {'NOT' flag, switches true and false}
           If Snot Then Begin
             Bad;
             Break;
           End Else
             Snot := True;
      '(': {System/75 processes anything within ()'s first.}
           Begin
             S := Copy (Str, 1, Pred (NextParan (Str)));
             Delete (Str, 1, NextParan (Str));
             Comp (HasAcs (S));
           End;
      '|': {'OR' flag, true if either two compared variables pass}
           If Snort Then Begin
             Bad;
             Break;
           End Else begin
             Snort := True;
             If Bool Then Break; { Complete Boolean Evaluation Not Needed }
             continue;
           end;
      '\': Comp (FailFlag);
      '=': Comp (Not Online);
      '[': Comp (Uc. NumNodes > 1);
      ';': Comp (InputBroke);
     '''': Comp (GetSysopPw (True));
      'K': Comp (CurArea = ReadNum);
      'L': Comp (CurBase = ReadNum);
      'M': Comp (CurmConf = ReadNum);
      'N': Comp (CurfConf = ReadNum);
      'P': Comp (User. fp >= ReadNum);
      'T': Comp (User. timeleft >= ReadNum);
      'U': Comp (User. UserNum = ReadNum);
      'A': begin
             now (n);
             Comp (YearsDif (User. bDay, N. d) >= ReadNum);
           end;
      'G': Comp (((Male In User. Options) And (ReadNum = 0)) Or ((Not (Male In User. Options)) And (ReadNum = 1)));
      'R': Comp (User. TotCalls > ReadNum);
      '*': Comp (Ratio (User. MsgPost, User. TotCalls) >= User. Pcr);
      'S': Comp (User. Sl >= ReadNum);
      'V': Comp (NodeNumber = ReadNum);
      'D': Comp (User. Dsl >= ReadNum);
      'E': Comp (User. ontoday > ReadNum);
      'Y': begin
             now (n);
             Comp (MinPastMidNite (n. t) >= ReadNum);
           end;
      'J': Begin
             L := ReadNum;
             If L = 3 Then
               If UsingRip Then
                 Comp (True)
               Else
                 Comp (False)
             Else
               Comp (tTermType (L) in DetectedEmu);
           End;
      'F': Comp ((Str <> '') And (pos (Str [1], User. Flags) <> 0));
      'C': begin
             now (n);
             Comp (N. d - User. passwordchanged >= ReadNum);
           end;
      'B': Comp (BaudRate Div 100 >= ReadNum);
      'Z': Comp (B (vToggles, 2));
      'O': comp (tmpsysop);
      'W': comp (mspons);
      'X': comp (fspons);
      'H': comp (hasacs (uc. vcosysopacs));
      'I': comp (hasacs (uc. vsysopacs));
      Else Bad;
    End;

    If Snort And Bool Then Break; { Complete Boolean Evaluation Not Needed }
    Snort := False;
  End;
  HasAcs := Bool;
End;

Function SysopAcs: BoOleAn;
Begin
  SysopAcs := TmpSysop or ibepimping or HasAcs (Uc. vSysopAcs);
End;

Function CoSysopAcs: BoOleAn;
Begin
  CoSysopAcs := TmpSysop or ibepimping or HasAcs (Uc. vCoSysopAcs);
End;
End.

