
 (*                                                                        *)
 (*                       S y s t e m / 7 5     S                        *)
 (*                                                                        *)
 (*                            I n s t a l l !                             *)
 (*                                                                        *)
 (*                           Version 1.05 eta                            *)
 (*                                                                        *)
 (*                    Compiled  Saturday, July 8, 1995                    *)
 (*                                                                        *)
 (*                   Copyright (c) 1995, Spectre Coding                   *)
 (*                                                                        *)
 (*                     Author: Clay McClure (maxwell)                     *)
 (*                                                                        *)

Program Install;

{$I Sys75.Inc}
{$M 10240, 0, 10000}

Uses
  Crt, Dos,
  Spuds,
  TotFast, TotInput, TotKey, TotMisc, TotStr,
  Crunches, Fades;

Const
  Block = '|08[|07|08]';

Var
  DosScreen: pScreenObj;
  NewConfig: ConfigType;
  Sys75Path: String [44];

Procedure GetStr (Len: Byte; Var S: String);
Var
  I: Word;
  C: Char;
  Ins: Boolean;
  fx, sx, P: Byte;
  ps: String;
Begin
  If Len > 254 then len := 254;
  ps := S;
  S := '';
  P := 1;
  Ins := True;
  fx := Screen^. WhereX;

  Repeat
    If ps <> '' Then Begin
      I := Ord (ps [1]);
      Delete (ps, 1, 1);
    End Else
      I := Key^. GetKey;

    C := uCase (Chr (Lo (I)));

    Case I of
      0, 256:;
      1..7:;
      8: If P <> 1 Then Begin
           If P = Succ (Length (S)) Then Begin
             Dec (S [0]);
             Screen^. Write (#8' '#8);
           End Else Begin
             Delete (S, Pred (P), 1);
             sx := Screen^. WhereX;
             Screen^. Write (#8 + Copy (S, Pred (P), 255) + ' ');
             Dec (sx);
             With Screen^ do
               GotoXy (sx, WhereY);
           End;
           Dec (P);
         End;
      9..12:;
      13: Break;
      14..31:;
      kLeft: If P <> 1 Then Begin
               With Screen^ do
                 GotoXy (Pred (WhereX), WhereY);
               Dec (P);
             End;
      kRight:If P <= Length (S) Then Begin
               With Screen^ do
                 GotoXy (Succ (WhereX), WhereY);
               Inc (P);
             End;
      kHome:
             Begin
               P := 1;
               With Screen^ do
                 GotoXy (fx, WhereY);
             End;
      kEnd:
             Begin
               P := Succ (Length (S));
               With Screen^ do
                 GotoXy (fx + Pred (P), WhereY);
             End;
      kIns: Ins := Not Ins;
      kDel: If P <> Succ (Length (S)) Then Begin
              Delete (S, P, 1);
              With Screen^ do Begin
                sx := WhereX;
                Write (Copy (S, P, 255) + ' ');
                GotoXy (sx, WhereY);
              End;
            End;
      Else If I < 256 Then Begin
        If Ins Then Begin
          If Length (S) >= Len Then Continue;
          sx := Succ (Screen^. wherex);
          screen^. write (C + Copy (S, P, 255));
          S := Copy (S, 1, Pred (P)) + C + Copy (S, P, 255);
          If P <> Length (S) Then
            Screen^. gotoxy (sx, wherey);
        End Else Begin
          If P > Len Then Continue;
          screen^. write (C);
          S [P] := C;
          If P = Length (S) Then Inc (S [0]);
        End;
        Inc (P);
      End;
    End;
  Until False;
End;

Function LiteBar (Yes: Boolean): Boolean;
Var
  X: Byte;
Const
  yn: Array [False..True] of String [20] = (' Yes ~ No ~', '~ Yes ~ No ');
Begin
  X := Screen^. WhereX;

  Repeat
    With Screen^ do
      WriteHi (X, WhereY, $1F, $0F, yn [Yes]);
    Case Key^. GetKey of
      kEsc: Begin
              TextAttr := 7;
              Writeln (^J^M^J'Aborted.'^M^J);
              Screen^. CursOn;
              Halt (0);
            End;
      kY, kSftY: Begin
                   Yes := True;
                   With Screen^ do
                     WriteHi (X, WhereY, $1F, $0F, yn [Yes]);
                   Break;
                 End;
      kN, kSftN: Begin
                   Yes := False;
                   With Screen^ do
                     WriteHi (X, WhereY, $1F, $0F, yn [Yes]);
                   Break;
                 End;
      kEnter: Break;
      kLeft, kRight, kSpc: Yes := Not Yes;
    End;
  Until False;

  LiteBar := Yes;
End;

{$I Inst}

Procedure Initialize;
Begin
  ShadowTot^. SetShadowStyle (DownRight, 0, ' ');
  InitFade;
  New (DosScreen, Init);

  Screen^. PartClear (1, Crt. WhereY, 80, 25, 8 , ' ');
  Screen^. WriteLn (^M + Block + ' |08S|07ys|15tem|08/|077|155 |15|07|08S |15I|07ns|08tall! ' + Block);
  Screen^. WriteLn ('|08    v' + Version + ', ' + VersionDate + ' ');
  Screen^. WriteLn ('   |07B|08rought |07t|08o |07y|08ou |07b|08y |08M|15i|08st |08  ');
  Screen^. WriteLn ('');

  If Not Exist ('INSTALL.DAT') Then Begin
    TextAttr := 7;
    Writeln (^J^M^J'Unable to find INSTALL.DAT.'^M^J);
    Screen^. CursOn;
    Halt (0);
  End;

  DosScreen^. Save;
  Delay (200);
  FadeOut (3);
  Screen^. Clear (0, ' ');
  Screen^. CursOff;
  Uncrunch (IntroScr, Mem [SegB800:0], IntroScrLen);
  FadeIn (2);
  Delay (1000);
  FadeOut (4);
  Screen^. Clear (0, ' ');
  Uncrunch (MainScr, Mem [SegB800:0], MainScrLen);
  FadeIn (2);
End;

Procedure MakeBatchFiles;
Var
  T: Text;
Begin
  If Sys75Path = '' then exit;

  Assign (T, Sys75Path + 'BBS.Bat');
  Rewrite (t);
  Dec (Sys75Path [0]);
  Writeln (t, '@echo off');
  Writeln (t);
  Writeln (t, ' REM ************************************************************************');
  Writeln (t, ' REM * This is an example of a batch file that allows errorcode events and  *');
  Writeln (t, ' REM * launching external systems from the bbs.                             *');
  Writeln (t, ' REM *                                                                      *');
  Writeln (t, ' REM * Any line preeceded by REM is a comment, and DOS will ignore anything *');
  Writeln (t, ' REM * on that line.                                                        *');
  Writeln (t, ' REM *                                                                      *');
  Writeln (t, ' REM * NOTE: This batch file takes ones optional parameter. You can specify *');
  Writeln (t, ' REM * the node number to run in multi-node systems on the command line,    *');
  Writeln (t, ' REM * ie., typing  BBS.BAT 2  would run node 2. If no parameter is given,  *');
  Writeln (t, ' REM * node 1 is loaded. If you need more help, read DOX\BATCH.DOX.         *');
  Writeln (t, ' REM ************************************************************************');
  Writeln (t);
  Writeln (t, 'set node=');
  Writeln (t, 'set node=%1');
  Writeln (t, 'if "%node%"=="" set node=1');
  Writeln (t, ' REM ** Sets up the node number parameter and makes the default node 1 **');
  Writeln (t);
  Writeln (t, 'set dszlog=' + Sys75Path + '\node%node%\dsz.log');
  Writeln (t, ' REM ** This sets an environment variable neccessary for most protocols **');
  Writeln (t);
  Writeln (t, ':top');
  Writeln (t, ' REM ** This starts a loop **');
  Writeln (t);
  Writeln (t, 'c:');
  Writeln (t, 'cd ' + Sys75Path);
  Writeln (t, ' REM ** Changes to default drive and directory. Change as needed **');
  Writeln (t);
  Writeln (t, 'Sys75.Exe -node %node%');
  Writeln (t, ' REM ** Runs system/75 here **');
  Writeln (t);
  Writeln (t, 'if errorlevel 100 c:\dw\dw.bat');
  Writeln (t, ' REM ** Default system with errorcode 100 is doorway. Change as needed **');
  Writeln (t, ' REM ** Put any other exitcode events or systems here **');
  Writeln (t, ' REM ** You have to put them in decreasing order of errorlevels!!! **');
  Writeln (t, ' REM ** ie., put  if errorlevel 100 then  before  if errorlevel 50 then  **');
  Writeln (t);
  Writeln (t, 'if errorlevel 0 goto end');
  Writeln (t, ' REM ** This will exit the loop if ''X'' is hit from the WFC screen **');
  Writeln (t);
  Writeln (t, 'goto top');
  Writeln (t, ' REM ** Otherwise go to the top of the loop again **');
  Writeln (t);
  Writeln (t, ':end');
  Writeln (t, ' REM ** Return to DOS **');
  Writeln (t);
  Writeln (t, 'set dszlog=');
  Writeln (t, ' REM ** Dispose of unneeded memory **');
  Writeln (t);

  Inc (Sys75Path [0]);
  Close (T);

  Assign (T, Sys75Path + 'FRONTEND.Bat');
  Rewrite (t);
  Dec (Sys75Path [0]);
  writeln (t, '@echo off');
  writeln (t);
  writeln (t, ' REM ************************************************************************');
  writeln (t, ' REM * This is an example of a batch file that allows the use of a front-   *');
  writeln (t, ' REM * end mailer and errorlevel events and the launching of extra systems. *');
  writeln (t, ' REM *                                                                      *');
  writeln (t, ' REM * Any line preeceded by REM is a comment, and DOS will ignore anything *');
  writeln (t, ' REM * on that line.                                                        *');
  writeln (t, ' REM *                                                                      *');
  writeln (t, ' REM * NOTE: This is setup for *Intermail*. You will need to alter some of  *');
  writeln (t, ' REM * this for other front-end mailers. Consult your mailer documentation. *');
  writeln (t, ' REM *                                                                      *');
  writeln (t, ' REM * NOTE: This batch file takes ones optional parameter. You can specify *');
  writeln (t, ' REM * the node number to run in multi-node systems on the command line,    *');
  writeln (t, ' REM * ie., typing "FRONTEND 2" would run node 2. If no parameter is given, *');
  writeln (t, ' REM * node 1 is loaded. If you need more help, read DOX\BATCH.DOX.         *');
  writeln (t, ' REM ************************************************************************');
  writeln (t);
  writeln (t, 'set node=');
  writeln (t, 'set node=%1');
  writeln (t, 'if "%node%"=="" set node=1');
  writeln (t, ' REM ** Sets up the node number parameter and makes the default node 1 **');
  writeln (t);
  writeln (t, 'set dszlog=c:\pas\sys75\node%node%\dsz.log');
  writeln (t, ' REM ** This sets an environment variable neccessary for most protocols **');
  writeln (t);
  writeln (t, ':top');
  writeln (t, ' REM ** This starts a loop **');
  writeln (t);
  writeln (t, 'c:');
  writeln (t, 'cd\im');
  writeln (t, ' REM ** Changes to front-end mailer directory. Change as needed **');
  writeln (t);
  writeln (t, 'im.exe');
  writeln (t, ' REM ** Runs front-end mailer program here. Change as needed **');
  writeln (t);
  writeln (t, ' REM ************************************************************************');
  writeln (t, ' REM * The following lines pass the connection speed to System/75.          *');
  writeln (t, ' REM * You must go into your front-end mailer config and set the connect    *');
  writeln (t, ' REM * strings to use these errorlevels. In IMSETUP, look under Modem, then *');
  writeln (t, ' REM * Advanced Setup, and then Connect Strings. Consult your front-end dox *');
  writeln (t, ' REM * for further help. You will need to add lines for any events you have *');
  writeln (t, ' REM * created with your mailer.                                            *');
  writeln (t, ' REM *                                                                      *');
  writeln (t, ' REM * NOTE: These are the standard connect rates for every modem from an   *');
  writeln (t, ' REM * ancient 300 baud to the latest 28,800 baud modems.                   *');
  writeln (t, ' REM *                                                                      *');
  writeln (t, ' REM * You have to put the errorlevels in decreasing order for it to work,  *');
  writeln (t, ' REM * ie., put  "if errorlevel 100"  before  "if errorlevel 99".           *');
  writeln (t, ' REM ************************************************************************');
  writeln (t, 'if errorlevel 113 set speed=28800');
  writeln (t, 'if errorlevel 112 set speed=26400');
  writeln (t, 'if errorlevel 111 set speed=24000');
  writeln (t, 'if errorlevel 110 set speed=21600');
  writeln (t, 'if errorlevel 109 set speed=19200');
  writeln (t, 'if errorlevel 108 set speed=16800');
  writeln (t, 'if errorlevel 107 set speed=14400');
  writeln (t, 'if errorlevel 106 set speed=12000');
  writeln (t, 'if errorlevel 105 set speed=9600 ');
  writeln (t, 'if errorlevel 104 set speed=7200 ');
  writeln (t, 'if errorlevel 103 set speed=4800 ');
  writeln (t, 'if errorlevel 102 set speed=2400 ');
  writeln (t, 'if errorlevel 101 set speed=1200 ');
  writeln (t, 'if errorlevel 100 set speed=300  ');
  writeln (t, ' REM ************************************************************************');
  writeln (t);
  writeln (t, 'if errorlevel 0 goto end');
  writeln (t, ' REM ** The line above is for if the mailer was manually exited locally **');
  writeln (t);
  writeln (t, 'c:');
  writeln (t, 'cd ' + Sys75Path);
  writeln (t, ' REM ** Changes to System/75 directory. Change as needed **');
  writeln (t);
  writeln (t, 'sys75.exe -node %node% -b %speed%');
  writeln (t, ' REM ** This runs the bbs with the specififed connect rate and node number **');
  writeln (t);
  writeln (t, 'if errorlevel 0 goto end');
  writeln (t, ' REM ** The line above is for if System/75 was manually exited locally **');
  writeln (t);
  writeln (t);
  writeln (t);
  writeln (t, ' REM ************************************************************************');
  writeln (t, ' REM * The following lines are used to run any events which were missed     *');
  writeln (t, ' REM * while the front-end mailer was running. Make sure the directory and  *');
  writeln (t, ' REM * drive used below are correct.                                        *');
  writeln (t, ' REM ************************************************************************');
  writeln (t, ':runevent');
  writeln (t, 'c:');
  writeln (t, 'cd ' + Sys75Path);
  writeln (t, 'sys75.exe -node %node% -events');
  writeln (t);
  writeln (t, 'REM ** Add any errorlevel events here, in decreasing order if you please **');
  writeln (t);
  writeln (t, 'if exist ' + Sys75Path + '\node%node%\events.run goto runevent');
  writeln (t, ' REM ************************************************************************');
  writeln (t);
  writeln (t);
  writeln (t);
  writeln (t, 'goto top');
  writeln (t, ' REM ** Go to the top of the loop again **');
  writeln (t);
  writeln (t, ':end');
  writeln (t, ' REM ** Front-end mailer or BBS exited with an errorlevel of 0 **');
  writeln (t);
  writeln (t, 'set speed=');
  writeln (t, 'set node=');
  writeln (t, 'set dszlog=');
  writeln (t, ' REM ** Recover any memory used by speed and node variables **');
  writeln (t, ' REM ** and return to DOS **');
  writeln (t);
  Inc (Sys75Path [0]);
  Close (T);
End;

Procedure FullInstall;

  Procedure GetPath;
  Begin
    Screen^. TitledBox (10, 18, 70, 20, $08, $0F, $19, 1, ' Select System/75 Directory ');
    Key^. FlushBuffer;
    Sys75Path := 'C:\SYS75\';
    Screen^. GotoXY (11, 19);
    Screen^. Curson;
    TextAttr := $19;
    GetStr (44, Sys75Path);
    Screen^. Cursoff;
    Sys75Path := fExpand (Sys75Path);
    Screen^. GotoXY (11, 19);
    Screen^. Write (Sys75Path);
    If Sys75Path [Length (Sys75Path)] <> '\' Then Begin
      Sys75Path := Sys75Path + '\';
      Screen^. Write ('\');
    End;
  End;

Var
  D: Integer;
  F: File of ConfigType;
  N: File of NodeDataType;
  S: String;
  temp: setrec;
  sf: file of setrec;
Begin
  Repeat
    Screen^. PartClear (1, 18, 80, 25, 8, ' ');
    GetPath;
    Screen^. GotoXy (10, 22);
    Screen^. Write ('|15S|07y|08stem/|077|155 |15w|08ill |15b|08e |15i|08nstalled |15t|08o |15' + Sys75Path + '|08.');
    Screen^. GotoXy (10, 23);
    Screen^. Write ('|15I|08s |15t|08his |15c|08orrect (ESC to abort)? ');
  Until LiteBar (True);
  Screen^. PartClear (1, 18, 80, 25, 8, ' ');
  Dec (Sys75Path [0]);
  If Not ExistDir (Sys75Path) Then Begin
    Screen^. PartClear (1, 18, 80, 25, 8, ' ');
    Screen^. GotoXy (10, 18);
    Screen^. Write ('|15C|08reating |15d|08irectory.');
    {$I-}
    MkDir (Sys75Path);
    {$IFDEF Debug}{$I+}{$ENDIF}
    If IoResult <> 0 Then Begin
      TextAttr := 7;
      Writeln (^J^M^J'Unable to create directory.'^M^J);
      Screen^. CursOn;
      Halt (0);
    End;
  End;
  Inc (Sys75Path [0]);
  Screen^. GotoXy (10, 19);
  Screen^. Write ('|15E|08xtracting |15f|08iles |15|BE...');
  RenameFile ('INSTALL.DAT', 'INSTALL!.EXE');

  S := GetEnv ('ComSpec');
  If S = '' Then
    If Exist ('C:\Command.Com') Then
      S := 'C:\Command.Com'
    Else If Exist ('C:\Dos\Command.Com') Then
      S := 'C:\Dos\Command.Com';
  If S = '' Then Begin
    TextAttr := 7;
    Writeln (^J^M^J'Unable to locate Command.Com.'^M^J);
    Screen^. CursOn;
    Halt (0);
  End;

  SwapVectors;
  Exec (S, '/C INSTALL!.EXE -D -N -O ' + Sys75Path + ' >NUL');
  D := DosError;
  SwapVectors;
  RenameFile ('INSTALL!.EXE', 'INSTALL.DAT');
  If D <> 0 Then Begin
    TextAttr := 7;
    Writeln (^J^M^J'Unable to extract files.'^M^J);
    Screen^. CursOn;
    Halt (0);
  End;

  Screen^. GotoXy (27, 19);
  Screen^. Write ('|08   ');
  Screen^. GotoXy (10, 20);
  Screen^. Write ('|15C|08reating |15b|08atch |15f|08iles:');
  MakeBatchFiles;
  Screen^. GotoXy (10, 21);
  Screen^. Write ('|15C|08reating |15d|08ata |15f|08iles:');

  With Uc Do Begin
    BordPath := Sys75Path + 'BOARDS\';
    FilePath := Sys75Path + 'FILES\';
    DoorPath := Sys75Path + 'DOORS\';
    MenuPath := Sys75Path + 'MENUS\';
    DataPath := Sys75Path + 'DATA\';
    NtMlPath := Sys75Path + 'NETMAIL\';
    FlAtPath := Sys75Path + 'ATTACH\';
    BadPath  := Sys75Path + 'BAD\';
    ScrpPath := Sys75Path + 'SCRIPTS\';
    DispPath := Sys75Path + 'DISP\';
    TmDlPath := Sys75Path + 'DOWNLOAD\';
    TmUlPath := Sys75Path + 'UPLOADS\';
    HelpPath := Sys75Path + 'HELP\';
    BasePath := Sys75Path;
  End;

  Assign (F, Sys75Path + 'Sys75.Cfg');
  Rewrite (F);
  Write (F, Uc);
  Close (F);

  With NodeData Do Begin
    NodePath := Sys75Path + 'NODE1\';
    TempPath := Sys75Path + 'NODE1\TEMP';
  End;

  Assign (N, Uc. DataPath + 'Node_1.Dat');
  Rewrite (N);
  Write (N, NodeData);
  Close (N);

  Dec (Sys75Path [0]);
  ChDir (Sys75Path);
  Inc (Sys75Path [0]);

  SwapVectors;
  Exec ('MakeStr.Exe', 'qwertyuiop');
  D := DosError;
  SwapVectors;
  If D <> 0 Then Begin
    TextAttr := 7;
    Writeln (^J^M^J'Error running MakeStr.Exe.'^M^J);
    Screen^. CursOn;
    Halt (0);
  End;

  assign (sf, uc. datapath + 'menuset.dat');
  rewrite (sf);
  with temp do begin
    path := uc. basepath + 'ld-menus\';
    name := 'lOrdJazz! menus';
  end;
  write (sf, temp);
  with temp do begin
    path := uc. basepath + 'ck-menus\';
    name := 'Chromatik menus';
  end;
  write (sf, temp);
  close (sf);

  assign (sf, uc. datapath + 'statset.dat');
  rewrite (sf);
  with temp do begin
    path := uc. basepath + 'bi-stats\';
    name := 'ishop Stat Set';
  end;
  write (sf, temp);
  close (sf);

  Screen^. GotoXy (10, 22);
  Screen^. Write ('|15R|08unning |15c|08onfig:');
  Screen^. CursOn;
  SwapVectors;
  Exec ('Sys75.Exe', WiggedOutTrippinMotherFucker);
  D := DosError;
  SwapVectors;
  TextAttr := 8;
  ClrScr;
  If D <> 0 Then Begin
    TextAttr := 7;
    Writeln (^J^M^J'Error running config.'^M^J);
    Screen^. CursOn;
    Halt (0);
  End;

  Uncrunch (MainScr, Mem [SegB800:0], MainScrLen);
  Screen^. CursOff;
  Screen^. GotoXy (10, 19);
  Screen^. Write ('|15I|08nstallation |15c|08omplete.');
  Screen^. GotoXy (10, 20);
  Screen^. Write ('|15P|08ress |15a|08ny |15k|08ey...');
  Key^. FlushBuffer;
  Key^. GetKey;
End;

Procedure Done;
Begin
  FadeOut (4);
  DosScreen^. Display;
  Dispose (DosScreen, Done);
  FadeIn (2);
End;

Begin
  Initialize;
  FullInstall;
  Done;
End.

