Program AnsiTerm;

{$I-,M 60000,0,70000}

uses
crt,dos,async;

Type
 CfgRecord=Record
            Idx,addr:word;                   {Commport# & Address}
            Init,Dial:string[38];            {Duh}
            Baud:longint;                    {Can you figure this one out?}
           end;
 DialRecord=record
             Name,Number:string[40];
            end;

Var
cfg:cfgrecord;
ScrBuf:array[0..4001]of byte;
c:char;
count:integer;
quit:boolean;

{--------------------------------------------------------------------}

Function Incoming:boolean;          {Sends true if keypressed or RD}

Begin
 incoming:=(keypressed or charwaiting);
end;

{--------------------------------------------------------------------}

Procedure SaveScreen;
begin
move(mem[$B800:0],ScrBuf,4000);
scrbuf[4000]:=wherex;
scrbuf[4001]:=wherey;
end;

{--------------------------------------------------------------------}

Procedure RestoreScreen;
var
x,y:byte;
begin
move(scrbuf,mem[$B800:0],4000);
x:=scrbuf[4000];
y:=scrbuf[4001];
gotoxy(x,y);
end;

{--------------------------------------------------------------------}

Procedure sendAT(str:string);   {Send string to modem}

var
 count:integer;
 b:byte;

begin
 str:=str+#13;
 for count := 1 to length(str) do
 begin
  transmit(str[count]);
 end;
end;

{--------------------------------------------------------------------}

procedure ANSIon;
begin
 assign(output,'');
 rewrite(output);
 write('[0;37;40m');
end;

{--------------------------------------------------------------------}

procedure ANSIoff;
begin
 assigncrt(output);
 rewrite(output);
end;

{--------------------------------------------------------------------}

Function Exists(Fname:string):boolean;
var
 DirInfo: SearchRec;
begin
 FindFirst(Fname,0, DirInfo);
 exists:=doserror=0;
end;

{--------------------------------------------------------------------}

Procedure Setup;
var
 cfgfile:file of cfgrecord;
begin
 with cfg do
 begin
  Clrscr;
  Writeln('Welcome to Chat Setup :');
  textcolor(14);
  writeln;
  write('Which comport is your modem on? (1-4) :');
  textcolor(15);
  c:=Readkey;
  writeln(c);
  case c of
   '1':begin
       idx:=1;
       addr:=$3F8;
       end;
   '2':begin
       idx:=2;
       addr:=$2F8;
       end;
   '3':begin
       idx:=3;
       addr:=$3E8;
       end;
   '4':begin
       idx:=4;
       addr:=$2E8;
       end;
  end;
  gotoxy(1,3);
  clreol;
  repeat
   textcolor(14);
   writeln('Choose a baud rate:');
   textcolor(15);writeln;
   writeln('  1: 1200bps.');
   writeln('  2: 2400bps.');
   writeln('  3: 4800bps.');
   writeln('  4: 9600bps.');
   writeln('  5: 14400bps.');
   writeln('  6: 19200bps.');
   writeln('  7: 38400bps.');
   writeln('  8: 57600bps.');
   writeln('  9: 115200bps.');
   gotoxy(20,3);
   c:=readkey;
   writeln(c);
   case c of
    '1':baud:=1200;
    '2':baud:=2400;
    '3':baud:=4800;
    '4':baud:=9600;
    '5':baud:=14400;
    '6':baud:=19200;
    '7':baud:=38400;
    '8':baud:=57600;
    '9':baud:=115200;
   end;
   for count:=3 to 13 do
   begin
    gotoxy(1,count);
    clreol;
   end;
  until (ord(c)>48)and(ord(c)<58);
  gotoxy(1,3);
  textcolor(14);
  write('What initilization string do you want? :');
  textcolor(15);
  readln(init);
  gotoxy(1,3);
  clreol;
  textcolor(14);
  write('What Dial string do you want? :');
  textcolor(15);
  readln(Dial);
  gotoxy(1,3);
  clreol;
  writeln('Thank you');
  assign(cfgfile,'Term.cfg');   {Assign file}
  rewrite(cfgfile);             {Rewrite file}
  write(cfgfile,cfg);           {Write Cfg}
  close(cfgfile);               {Close CfgFile}
  textcolor(15);
  writeln('File saved as "TERM.CFG"');
  delay(2000);
  clrscr;
 end;
end;

{--------------------------------------------------------------------}

Procedure createlist;
var
 Num:Dialrecord;
 Numfile,Tfile:file of Dialrecord;
begin
 num.name:='Digital Decay BBS';
 num.number:='1-714-871-2057';
 assign(numfile,'PHONELST.DAT');
 rewrite(numfile);
 write(numfile,num);
 close(numfile);
end;

{--------------------------------------------------------------------}

Procedure InitTerm;

Var
 count:integer;
 CfgFile: File of CfgRecord;

Begin
 quit:=false;
 textmode(3);
 textcolor(7);
 textbackground(0);
 if (not exists('Term.Cfg'))or(paramstr(1)='S')or(paramstr(1)='s')then Setup;
 if not exists('PhoneLst.Dat') then createlist;
 filemode:=2;
 Assign(CfgFile,'Term.cfg');
 Reset(CfgFile);
 read(cfgfile,cfg);
 close(cfgfile);
 init(cfg.idx,cfg.baud);
 port[cfg.addr]:=255;
 flushcomm;
 clrscr;
 Textcolor(14);
 writeln('Welcome to ANSITerm by Slack, press F1 for help.');
 textcolor(7);
 sendAT(cfg.init);
 Ansion;
end;

{--------------------------------------------------------------------}

Procedure Help;
begin
 savescreen;
 ansioff;
 textcolor(14);
 textbackground(1);
 gotoxy(23,7);write('ͻ');
 gotoxy(23,8);write(' ');
 textcolor(15);write(' ANSITerm HELP!                ');
 textcolor(14);write('');
 gotoxy(23,9);write('Ķ');
 gotoxy(23,10);write(' ');
 textcolor(15);write('    F1 : This help menu        ');
 textcolor(14);write('');
 gotoxy(23,11);write(' ');
 textcolor(15);write('  PgDn : Recieve a file        ');
 textcolor(14);write('');
 gotoxy(23,12);write(' ');
 textcolor(15);write('  PgUp : Send a file           ');
 textcolor(14);write('');
 gotoxy(23,13);write(' ');
 textcolor(15);write(' Alt-S : Run Setup             ');
 textcolor(14);write('');
 gotoxy(23,14);write(' ');
 textcolor(15);write(' Alt-D : Dial out              ');
 textcolor(14);write('');
 gotoxy(23,15);write(' ');
 textcolor(15);write(' Alt-P : Phone List            ');
 textcolor(14);write('');
 gotoxy(23,16);write(' ');
 textcolor(15);write(' Alt-C : Clear the screen      ');
 textcolor(14);write('');
 gotoxy(23,17);write(' ');
 textcolor(15);write(' Alt-H : Hang up modem         ');
 textcolor(14);write('');
 gotoxy(23,18);write(' ');
 textcolor(15);write(' Alt-X : Exit                  ');
 textcolor(14);write('');
 gotoxy(23,19);write('ͼ');
 gotoxy(1,1);
 readkey;
 ansion;
 restorescreen;
end;

{--------------------------------------------------------------------}

Procedure Hangup;
begin
 savescreen;
 ansioff;
 textcolor(14);
 textbackground(1);
 gotoxy(23,11);
 write('ͻ');
 gotoxy(23,12);write(' ');
 textcolor(15);write('Now disconnecting the modem... ');
 textcolor(14);write('');
 gotoxy(23,13);
 write('ͼ');
 gotoxy(1,1);
 port[cfg.addr+4]:=0;           {Drops DTR, works pretty well}
 delay(2500);
 ansion;
 restorescreen;
end;

{--------------------------------------------------------------------}

Procedure Runsetup;
begin
 savescreen;
 ansioff;
 textcolor(14);
 textbackground(0);
 ClrScr;
 writeln('Current settings for ANSI Chat are :');
 writeln;
 Textcolor(15);write('  Comport      : ');
 Textcolor(11);writeln('COM',cfg.idx);
 Textcolor(15);write('  Port Address : ');
 Textcolor(11);
 case cfg.idx of
  1:writeln('3F8');
  2:writeln('2F8');
  3:writeln('3E8');
  4:writeln('2E8');
 end;
 Textcolor(15);write('  Baud Rate    : ');
 Textcolor(11);writeln(cfg.baud,'bps');
 Textcolor(15);write('  Init String  : ');
 Textcolor(11);writeln(cfg.init);
 Textcolor(15);write('  Dial String  : ');
 Textcolor(11);writeln(cfg.dial);
 textcolor(14);
 writeln;
 write('Do you want to change these settings? (Y/N) :');
 if upcase(readkey)='Y'then
 begin
  Setup;
  clrscr;
  textcolor(4);
  Writeln('Restarting ANSITerm with new parameters');
  textcolor(7);
  write('Press any key to continue...');
  readkey;
  hangup;
  textcolor(7);
  textbackground(0);
  clrscr;
  shutdown;
  ansioff;
  initterm;
 end else
 begin
  ansion;
  restorescreen;
 end;
end;

{--------------------------------------------------------------------}

Procedure Leave;
begin
 savescreen;
 ansioff;
 textcolor(14);
 textbackground(1);
 gotoxy(20,11);
 write('ͻ');
 gotoxy(20,12);write(' ');
 textcolor(15);write('Are you sure you want to quit? (Y/N) ');
 textcolor(14);write('');
 gotoxy(20,13);
 write('ͼ');
 gotoxy(1,1);
 repeat
 c:=upcase(readkey);
 until(c='Y')or(c='N');
 if c='Y' then
 begin
  quit:=true;
  textcolor(15);
  gotoxy(22,12);write('   Hang up the modem first? (Y/N)    ');
  repeat
   c:=upcase(readkey);
  until(c='Y')or(c='N');
  restorescreen;
  if c='Y' then hangup;
 end else
  c:=#0;
 restorescreen;
 ansion;
end;

{--------------------------------------------------------------------}

Function GetStr(x,y,len:integer):string;

var
 Tempstr:string;
 loop:integer;
 b:char;

begin
 gotoxy(x,y);
 textbackground(2);
 textcolor(15);
 for loop:=1to len do write(' ');
 gotoxy(x,y);
 tempstr:='';
 count:=0;
 repeat
  b:=readkey;
  if(b=#8)and(count>0)then
  begin
   count:=count-1;
   gotoxy(wherex-1,wherey);
   write(' ');
   gotoxy(wherex-1,wherey);
   delete(tempstr,length(tempstr),1);
  end;
  if(b<>#8)and(b<>#13)then
  begin
   write(b);
   tempstr:=concat(tempstr,b);
   count:=count+1;
  end;
 until(b=#13)or(b=#27)or(count=Len);
 if b<>#27 then getstr:=tempstr else getstr:='';
end;

{--------------------------------------------------------------------}

Procedure Phonebook;
var
 Num,temp:Dialrecord;
 Numfile,Tfile:file of Dialrecord;
 Cur,Tot,loop:integer;
begin
 savescreen;
 ansioff;
 textbackground(1);Textcolor(14);
 gotoxy(19,8); write('ͻ');
 gotoxy(19,9); write('');
 textcolor(7);write(' Name :                                 ');
 textcolor(14);write('');
 gotoxy(19,10);write('');
 textcolor(7);write('                                        ');
 textcolor(14);write('');
 gotoxy(19,11);write('');
 textcolor(7);write(' Number :                               ');
 textcolor(14);write('');
 gotoxy(19,12);write('');
 textcolor(7);write('                                        ');
 textcolor(14);write('');
 gotoxy(19,13);write('');
 textcolor(7);write(' Record(       of       )[+]Next[-]Prev ');
 textcolor(14);write('');
 gotoxy(19,14);write('');
 textcolor(7);write('  [E]dit [A]dd [R]emove [D]ial [Q]uit   ');
 textcolor(14);write('');
 gotoxy(19,15);write('ͼ');
 Textcolor(15);
 gotoxy(46,13);write('+');gotoxy(53,13);write('-');
 gotoxy(23,14);write('E');gotoxy(30,14);write('A');
 gotoxy(36,14);write('R');gotoxy(45,14);write('D');
 gotoxy(52,14);write('Q');
 assign(numfile,'PHONELST.DAT');
 reset(numfile);
 tot:=filesize(numfile);
 Cur:=1;
 repeat
  Seek(numfile,cur-1);
  read(numfile,num);
  Textcolor(15);
  gotoxy(21,10);for loop:=1to 38 do write(' ');
  gotoxy(21,10);write(num.Name);
  gotoxy(21,12);for loop:=1to 26 do write(' ');
  gotoxy(21,12);write(num.Number);
  gotoxy(28,13);write(cur:6);
  gotoxy(38,13);write(tot:6);
  gotoxy(1,1);
  c:=upcase(readkey);
  Case c of
  '+':if cur<tot then cur:=cur+1 else cur:=1;
  '-':If  cur>1  then cur:=cur-1 else cur:=Tot;
  #13:c:='D';
  'E':begin
       temp:=num;
       num.name:=getstr(21,10,38);
       if num.name=''then num.name:=temp.name;
       textcolor(15);textbackground(1);
       gotoxy(21,10);for loop:=1to 38 do write(' ');
       gotoxy(21,10);write(num.Name);
       num.Number:=getstr(21,12,26);
       if num.number=''then num.number:=temp.number;
       textcolor(15);textbackground(1);
       gotoxy(21,12);for loop:=1to 26 do write(' ');
       gotoxy(21,12);write(num.Number);
       Seek(numfile,cur-1);
       Write(numfile,num);
      end;
  'A':begin
       tot:=tot+1;
       cur:=tot;
       gotoxy(21,12);for loop:=1to 26 do write(' ');
       num.name:=getstr(21,10,38);
       textcolor(15);textbackground(1);
       gotoxy(21,10);for loop:=1to 38 do write(' ');
       gotoxy(21,10);write(num.Name);
       num.Number:=getstr(21,12,26);
       textcolor(15);textbackground(1);
       gotoxy(21,12);for loop:=1to 26 do write(' ');
       gotoxy(21,12);write(num.Number);
       Seek(numfile,cur-1);
       Write(numfile,num);
      end;
  'R':if tot>1 then
      begin
       assign(tfile,'Temp');
       rewrite(tfile);
       seek(numfile,0);
       for loop :=1to tot do
       begin
        read(numfile,num);
        if loop<>cur then write(tfile,num);
       end;
       tot:=tot-1;
       cur:=1;
       close(numfile);
       assign(numfile,'PHONELST.DAT');
       rewrite(numfile);
       seek(tfile,0);
       for loop :=1to tot do
       begin
        read(tfile,num);
        write(numfile,num);
       end;
       erase(tfile);
       close(numfile);
       assign(numfile,'PHONELST.DAT');
       reset(numfile);
      end else write('');
  end;
 until(c='Q')or(c='')or(c='D');
 close(numfile);
 if c='D' then
 begin
  restorescreen;
  textcolor(14);
  gotoxy(26,11);write('ͻ');
  gotoxy(26,12);write('');
  textcolor(15);write(' Now dialing out...       ');
  textcolor(14);write('');
  gotoxy(26,13);write('                          ');
  gotoxy(26,14);write('ͼ');
  textcolor(15);
  gotoxy(40-(length(num.number)div 2),13);write(num.number);
  sendat(cfg.dial+num.number);
  delay(500);
  flushcomm;
  gotoxy(1,1);
  repeat until incoming;
  if keypressed then
  begin
   readkey;
   restorescreen;
   hangup;
   shutdown;
   init(cfg.idx,cfg.baud);
   port[cfg.addr]:=255;
  end;
 end;
 ansion;
 restorescreen;
 c:=#0;
end;

{--------------------------------------------------------------------}

Procedure Dial;
var
 dStr:string;
begin
 savescreen;
 ansioff;
 textcolor(14);
 textbackground(1);
 gotoxy(26,11);write('ͻ');
 gotoxy(26,12);write('');
 textcolor(15);write(' Enter the number to dial ');
 textcolor(14);write('');
 gotoxy(26,13);write('>                        <');
 gotoxy(26,14);write('ͼ');
 dstr:=Getstr(28,13,24);
 if dstr<>'' then
 begin
  textcolor(15);
  textbackground(1);
  gotoxy(27,12);write(' Now dialing out...       ');
  gotoxy(27,13);write('                          ');
  gotoxy(40-(length(dstr)div 2),13);write(dstr);
  sendat(cfg.dial+dstr);
  delay(500);
  flushcomm;
  repeat until incoming;
  if keypressed then
  begin
   readkey;
   restorescreen;
   hangup;
   shutdown;
   init(cfg.idx,cfg.baud);
   port[cfg.addr]:=255;
  end;
 end;
 ansion;
 restorescreen;
 c:=#0;
end;

{--------------------------------------------------------------------}

Procedure Recivefile;
var
 fname,command,temp:string;
begin
 savescreen;
 ansioff;
 textcolor(14);
 textbackground(1);
 gotoxy(26,9); write('ͻ');
 gotoxy(26,10);write(' ');
 textcolor(15);write('Choose Downloading mode: ');
 textcolor(14);write('');
 gotoxy(26,11);write(' ');
 textcolor(15);write('[X]modem                 ');
 textcolor(14);write('');
 gotoxy(26,12);write(' ');
 textcolor(15);write('Xmodem-[C]rc             ');
 textcolor(14);write('');
 gotoxy(26,13);write(' ');
 textcolor(15);write('Xmodem-[O]verthrust      ');
 textcolor(14);write('');
 gotoxy(26,14);write(' ');
 textcolor(15);write('[Y]Modem                 ');
 textcolor(14);write('');
 gotoxy(26,15);write(' ');
 textcolor(15);write('[Z]modem                 ');
 textcolor(14);write('');
 gotoxy(26,16);write(' ');
 textcolor(15);write('Zmodem-[M]oby            ');
 textcolor(14);write('');
 gotoxy(26,17);write('ͼ');
 C := UpCase(ReadKey);
 str(cfg.idx,temp);
 command:='';
 if (Pos(C, 'XCOYZM') > 0) then
      case C of
        'X',
        'C',
        'O' : begin
                restorescreen;
                textcolor(14);
                textbackground(1);
                gotoxy(26,11);
                write('ͻ');
                gotoxy(26,12);write(' ');
                textcolor(15);write('Enter the file to recive:');
                textcolor(14);write('');
                gotoxy(26,13);write('>');
                Textbackground(2);write('                        ');
                textbackground(1);
                textcolor(14);write('<');
                gotoxy(26,14);
                write('ͼ');
                Fname:=Getstr(28,13,24);
                if fname='' then
                begin
                 ansion;
                 restorescreen;
                 exit;
                end else
                 begin
                   case C of
                     'X' :command:=concat('port ',temp,' d pV1 rx ',fname);
                     'C' :command:=concat('port ',temp,' d pV1 rc ',fname);
                     'O' :command:=concat('port ',temp,' d pV1 ro ',fname);
                   end;
                 end
              end;
        'Y' :command:=concat('port ',temp,' d pV1 rb');
        'Z' :command:=concat('port ',temp,' d pV1 rz -y -rr');
        'M' :command:=concat('port ',temp,' d pV1 rz -y -rr -m');
      end;
  SwapVectors;
  Exec('GSZ.EXE',command);
  Swapvectors;
 ansion;
 restorescreen;
 c:=#0;
end;

{--------------------------------------------------------------------}

Procedure Sendfile;
var
 fname,temp,command:string;
begin
 savescreen;
 ansioff;
 textcolor(14);
 textbackground(1);
 gotoxy(26,9
 ); write('ͻ');
 gotoxy(26,10);write(' ');
 textcolor(15);write('Choose Uploading mode:   ');
 textcolor(14);write('');
 gotoxy(26,11);write(' ');
 textcolor(15);write('[X]modem                 ');
 textcolor(14);write('');
 gotoxy(26,12);write(' ');
 textcolor(15);write('Xmodem-[C]rc             ');
 textcolor(14);write('');
 gotoxy(26,13);write(' ');
 textcolor(15);write('[Y]modem                 ');
 textcolor(14);write('');
 gotoxy(26,14);write(' ');
 textcolor(15);write('YModem-[1]K              ');
 textcolor(14);write('');
 gotoxy(26,15);write(' ');
 textcolor(15);write('YModem-[G]               ');
 textcolor(14);write('');
 gotoxy(26,16);write(' ');
 textcolor(15);write('[Z]Modem                 ');
 textcolor(14);write('');
 gotoxy(26,17);write(' ');
 textcolor(15);write('ZModem-[M]oby            ');
 textcolor(14);write('');
 gotoxy(26,18);write('ͼ');
 gotoxy(1,1);
 C := UpCase(ReadKey);
 str(cfg.idx,temp);
 command:='';
 if (Pos(C, 'XC1YGZM') > 0) then
  begin
  repeat
   restorescreen;
   textcolor(14);
   textbackground(1);
   gotoxy(26,11);
   write('ͻ');
   gotoxy(26,12);write(' ');
   textcolor(15);write('Enter the file to send:  ');
   textcolor(14);write('');
   gotoxy(26,13);write('>');
   Textbackground(2);write('                        ');
   textbackground(1);
   textcolor(14);write('<');
   gotoxy(26,14);
   write('ͼ');
   Fname:=Getstr(28,13,24);
  until(fname='')or(exists(fname));
   if fname='' then
   begin
    ansion;
    restorescreen;
    exit;
   end else
   begin
    case C of
'X','C':command:=concat('port ',temp,' d pV1 sx ',fname);
   '1' :command:=concat('port ',temp,' d pV1 sb k ',fname);
'Y','G':command:=concat('port ',temp,' d pV1 sb ',fname);
   'Z' :command:=concat('port ',temp,' d pV1 sz -rr ',fname);
   'M' :command:=concat('port ',temp,' d pV1 sz -m -rr ',fname);
    end;
   end;
   textcolor(7);
   textbackground(0);
   clrscr;
   SwapVectors;
   Exec('GSZ.EXE',command);
   Swapvectors;
  end;
 ansion;
 restorescreen;
 c:=#0;
end;


{--------------------------------------------------------------------}

Procedure handlevirtkey;

var
 b:char;

begin
 if keypressed then b:=readkey else exit;
 Case b of
 ';':help;
 'I':SendFile;
 'Q':ReciveFile;
 '':Runsetup;
 ' ':Dial;
 '':PhoneBook;
 '.':begin
      textcolor(7);
      textbackground(0);
      ClrScr;
     end;
 '#':begin
      Hangup;
      shutdown;
      init(cfg.idx,cfg.baud);
      port[cfg.addr]:=255;
      sendat(cfg.init);
     end;
 '-':Leave;
 end;
textcolor(7);
textbackground(0);
c:=#0;
end;

{--------------------------------------------------------------------}

Procedure run;
begin
repeat
 if incoming then
 begin
 if keypressed then
  begin
  c:=readkey;
  if c=#0 then handlevirtkey;
  if c>#0 then transmit(c);
  end
  else
  begin
  c:=receive;
  if c<>''then
  write(c) else clrscr;
  end;
 end;
until Quit;
end;

{--------------------------------------------------------------------}

begin
initTerm;
run;
textcolor(7);
textbackground(0);
clrscr;
writeln('Thank you for using ANSITerm');
shutdown;
end.