       Specification of CMOS Real Time Clock Interrupt Service (INT 70H)
       ------------------------------------------------------------------

* This routine handles the periodic and alarm interrupt interrupt from the 
  RTC.
  Input frequency is 1.024 KHz or approximately 1024 interrupts every
  second (programmed by POST) for the periodic interrupt. For the alarm
  function, the interrupt will occur at the designated time.
* Interrupts are enabled when the event or alarm function and interrupt of
  RTC (IRQ8) is activated.
* For the periodic interrupt, the handler will decrement the wait counter
  (double word located at 40:9C) when it down count to nothing will clear 
  the flag of RTC wait (location at 40:A0) and set 80H to the designated 
  location (a pointer stored in 40:98).
* For the alarm interrupt, the handler will issue INT 4AH which is provided
  by the users prior to setting the real time clock alarm (INT 1AH, 
  AH= 06H).

input:
                none
output:
                none

reference BIOS data area:

        40:98   offset of user wait flag
        40:9A   segment of user wait flag
        40:9C   low word of user wait count
        40:9E   high word of user wait count
        40:A0   wait active flag
                = 00h -- POST acknowledged
                = 01h -- busy
                = 80h -- POSTED

port defined:

        70h --- RT/CMOS RAM address and NMI Mask
        71h --- RT/CMOS data port

Note:
 1. Subtract 976.5625 from the wait count every periodic interrupt because
    the unit of the wait count is microsecond.
    (1000000 us / 1024 = 976.5625 us)
