               Interrupts defined in BIOS level of ACER
               ----------------------------------------

A. Interrupt vectors

     Ŀ
      Interrupt            Function                                  
      number (hex)                                                   
     Ĵ
           0         Temporary interrupt                             
     Ĵ
           1         Temporary interrupt                             
     Ĵ
           2         NMI interrupt service routine                   
     Ĵ
           3         Temporary interrupt                             
     Ĵ
           4         Temporary interrupt                             
     Ĵ
           5         Print screen service routine                    
     Ĵ
           6         Temporary interrupt                             
     Ĵ
           7         Temporary interrupt                             
     Ĵ
           8         System timer (IRQ 0)                            
     Ĵ
           9         Keyboard H/W interrupt                          
     Ĵ
           a         Temporary interrupt (IRQ 2)                     
     Ĵ
           b         Temporary interrupt (IRQ 3)                     
     Ĵ
           c         Temporary interrupt (IRQ 4)                     
     Ĵ
           d         Temporary interrupt (IRQ 5)                     
     Ĵ
           e         Diskette drive interrupt (IRQ 6)                
     Ĵ
           f         Temporary interrupt (IRQ 7)                     
     Ĵ
          10         Video I/O                                       
     Ĵ
          11         Equipment determination                         
     Ĵ
          12         Memory size determination                       
     Ĵ
          13         Diskette I/O                                    
     Ĵ
          14         Asynchronous communications                     
     Ĵ
          15         System service routines                         
     

     Ŀ
      interrupt            function                                  
      number (hex)                                                   
     Ĵ
          16         Keyboard I/O                                    
     Ĵ
          17         Printer I/O                                     
     Ĵ
          18         BASIC interrupt vector                          
     Ĵ
          19         Booting system                                  
     Ĵ
          1a         Set/Read Clock                                  
     Ĵ
          1b         Control break interrupt (null return)           
     Ĵ
          1c         Timer tick (null return)                        
     Ĵ
          1d         Pointer to video parameter table                
     Ĵ
          1e         Diskette parameter table vector                 
     Ĵ
          1f         Graphics character font pointer for modes 4,5,6 
     Ĵ
        21 - 3f      reserved for OS. or other functions             
     Ĵ
          40         Diskette I/O (when fixed disk exists)           
     Ĵ
          41         Fixed disk 0 parameter table vector             
     Ĵ
          42         reserved                                        
     Ĵ
          43         Graphics character font pointer for modes 11,13 
     Ĵ
        44 - 45      reserved                                        
     Ĵ
          46         Fixed disk 1 parameter table vector             
     Ĵ
        47 - 49      reserved                                        
     Ĵ
          4a         RTC Alarm  (null return)                        
     Ĵ
        4b - 6f      reserved                                        
     Ĵ
          70         Hardware real time clock (IRQ 8)                
     Ĵ
          71         Redirect interrupt (IRQ 9)                      
     Ĵ
          72         reserved (IRQ 10)                               
     Ĵ
          73         reserved (IRQ 11)                               
     Ĵ
          74         Pointing device (IRQ 12)                        
     Ĵ
          75         Coprocessor (IRQ 13)                            
     Ĵ
          76         Fixed Disk Controller (IRQ 14)                  
     Ĵ
          77         Reserved (IRQ 15)                               
     


B. BIOS entry point 

   Segment : 0F000h

     Ŀ
        Offset               Description                             
     Ĵ
        0E00Eh        'IBM'                                          
     Ĵ
        0E05Bh        Start                                          
     Ĵ
        0E2C3h        INT 02h                                        
     Ĵ
        0E6F2h        INT 19h                                        
     Ĵ
        0E739h        INT 14h                                        
     Ĵ
        0E82Eh        INT 16h                                        
     Ĵ
        0E987h        INT 09h                                        
     Ĵ
        0EC59h        INT 13h                                        
     Ĵ
        0EF57h        INT 0Eh                                        
     Ĵ
        0EFC7h        INT 1Eh (diskette base table)                  
     Ĵ
        0EFD2h        INT 17h                                        
     Ĵ
        0F065h        INT 10h                                        
     Ĵ
        0F0A4h        INT 1Dh (Video parameter table)                
     Ĵ
        0F841h        INT 12h                                        
     Ĵ
        0F84Dh        INT 11h                                        
     Ĵ
        0F859h        INT 15h                                        
     Ĵ
        0FA66h        Setup routine                                  
     Ĵ
        0FA6Eh        Graphics Pattern                               
     Ĵ
        0FE6Eh        INT 1Ah                                        
     Ĵ
        0FEA5h        INT 08h                                        
     Ĵ
        0FEF3h        Vector table                                   
     

     -- To be continued --

     Ŀ
        0FF53h        Dummy return                                   
     Ĵ
        0FF54h        INT 05h                                        
     Ĵ
        0FFEEh        BIOS checksum                                  
     Ĵ
        0FFF0h        CPU reset entry                                
     Ĵ
        0FFF5h        BIOS release date (mm/dd/yy)                   
     Ĵ
        0FFFEh        Machine model                                  
     Ĵ
        0FFFFh        Sub machine model                              
     
